package simulation.model;

import simulation.util.Vector2d;

import java.util.function.Function;

public class PhysicalObject {
    public final int width;
    public final int height;

    private boolean seen = false;

    private Vector2d position;

    public PhysicalObject(int width, int height, float x, float y) {
        this.width = width;
        this.height = height;

        this.position = new Vector2d(x, y);
    }

    public void updatePosition(Function<Vector2d, Vector2d> translation) {
        position = translation.apply(position);
    }

    public Vector2d getPosition() {
        return position;
    }

    public boolean isSeen() {
        return seen;
    }

    public void markSeen() {
        seen = true;
    }
}
