package simulation.results;

import simulation.model.Simulation;

import java.util.Collection;

public final class SimulationResult {
    public final Simulation simulation;
    public final Collection<Integer> seenTimestamps;
    public final Collection<Integer> missedTimestamps;
    public final Collection<Integer> criticalMisses;
    public final double energyUsed;

    public SimulationResult(Simulation simulation, Collection<Integer> seenTimestamps, Collection<Integer> missedTimestamps, Collection<Integer> criticalMisses, double energyUsed) {
        this.simulation = simulation;
        this.seenTimestamps = seenTimestamps;
        this.missedTimestamps = missedTimestamps;
        this.criticalMisses = criticalMisses;
        this.energyUsed = energyUsed;
    }

    public float percentageMissed() {
        return (float) missedTimestamps.size() / (float) (missedTimestamps.size() + seenTimestamps.size()) * 100.0f;
    }

    public float percentageCriticalMiss() {
        return (float) criticalMisses.size() / (float) (missedTimestamps.size() + seenTimestamps.size()) * 100.0f;
    }
}
